#include <petscdmda.h>
#include <petscksp.h>
#include <petscpcmg.h>
#include <petscdmmg.h>

#include <petscsys.h>

#define cntx 7.0
#define cnty 6.0
// grid dimension is : [(imax*4+1) * (jmax*4+1)] with ghost grids and [(imax*4-1) * (jmax*4-1)] without ghost grids
// domain dimension is : [{-dxValue ~ (imax*4-1)*dxValue} * {-dyValue ~ (jmax*4-1)*dyValue}]  with ghost grids 
//[{0 ~ (imax*4-2)*dxValue} * {0 ~ (jmax*4-2)*dyValue}]  without ghost grids 
#define imax 210
#define jmax 120 
#define dxValue 0.025
#define dyValue 0.025 
#define CD 400
#define crclnm 360
#define rr 0.5
#define PI 3.1415926535

typedef enum {DIRICHLET, NEUMANN} BCType;

typedef struct {
  PetscReal x[CD], y[CD];
} Geometry;

typedef struct {
  PetscScalar   rho;
  PetscScalar   nu;
  BCType        bcType;
} UserContext;

typedef struct {
  PetscInt uc;
  PetscInt vc;
  PetscInt pc;
} Flag;

typedef struct {
  PetscScalar x;
  PetscScalar y;
} StaggerGrid;
